interface FormDataOptions {
    /** Props with `null` OR `undefined` will be written as empty-string; otherwise it's skipped */
    includeNulls?: boolean;
    /** Point true for bracket-notation, otherwise dot-notation by default
     * * For NodeJS use bracket-notation `options[slots][0][isEnabled]: "true"`
     * * For .NET use dot-notation `"options.slots[0].isEnabled": "true"` */
    bracketNotation?: boolean;
}
/** Converts pointed object with nested properties to plain FormData
 * @returns Pointed formData or new FormData */
export default function objectToFormData(fromObj: Record<string, any> | Array<any>, toForm?: FormData | null, opts?: FormDataOptions | null): FormData;
export {};
